<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <!-- Import DataTable Library -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <!-- Import Datatable sau jquery -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <title>Task 38.30</title>
</head>

<body>
    <div class="container mt-4">
        <h2 class="text-center">Lucky Dice History</h2>
        <div class='row jumbotron p-3 m-0'>
            <div class='col-md-12'>
                <form>
                    <div class="form-row">
                        <h5>Thông tin người chơi</h5>
                    </div>
                    <div class='form-row'>
                        <div class="form-group col-md-4">
                            <label>Username</label>
                            <input type="text" id="user-name" class="form-control bg-secondary text-white" disabled />
                        </div>
                        <div class="form-group col-md-4">
                            <label>First Name</label>
                            <input type="text" id='first-name' class="form-control bg-secondary text-white" disabled />
                        </div>
                        <div class="form-group col-md-4">
                            <label>Last Name</label>
                            <input type="text" id="last-name" class="form-control bg-secondary text-white" disabled />
                        </div>
                    </div>
                </form>
            </div>
        </div>
        <div id="log-result" class="mt-5"></div>
        <div class="mt-5">
            <table id="table-dice-history" class="table table-bordered table-striped table-hover">
                <thead class="thead-dark">
                    <tr>
                        <th scope='col'>Game</th>
                        <th scope='col'>Dice</th>
                    </tr>
                </thead>
                <tbody>
                </tbody>
            </table>
        </div>
    </div>
    <script>
        "use strict";
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        const gBASE_URL = "http://203.171.20.210:8080/devcamp-lucky-dice/";
        var gPlayerInfoObj = {};
        var gDiceHistoryData = [];
        var gNameCol = ["stt", "dice"];
        const gSTT_COL = 0;
        const gDICE_POINT_COL = 1;
        var gPlayerDataTable = $('#table-dice-history').DataTable({
            columns: [
                { data: gNameCol[gSTT_COL] },
                { data: gNameCol[gDICE_POINT_COL] }
            ],
            columnDefs: [ //định nghĩa các cột cần hiện ra
                {
                    targets: gSTT_COL, //cột STT
                    className: "text-center text-primary",
                    render: function (data, type, row, meta) {
                        return meta.row + meta.settings._iDisplayStart + 1;
                    }
                },
                {
                    targets: gDICE_POINT_COL,
                    className: "text-center text-success",
                }
            ]
        });
        function onBtnDiceHistoryClick(paramDataRow) { //xử lý chuyển trang sang Trang diceHistory.html 
            const VDETAIL_FORM_URL = "diceHistory.html"
            var vurlSiteToOpen = VDETAIL_FORM_URL +
                "?user_name=" + paramDataRow.username +
                "&first_name=" + paramDataRow.firstname +
                "&last_name=" + paramDataRow.lastname;
            location.href = vUrlSiteToOpen;
        }
        /*** REGION 2 - Vùng gần / thực thi sự kiện cho các elements */
        onPageLoading();
        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {// get data from query string
            var vCurrentURL = window.location.href; // đường đẫn gọi đến trang catchDataFromURL (vCurrentURL);
            loadPlayerInfoToForm(gPlayerInfoObj);
            getPlayerDiceHistory(gPlayerInfoObj.userName);
        }
        // Hàm xử lý thực hiện lấy queryString từ Url trang web
        function catchDataFromURL(paramsCurrentURL) {
            "use strict";
            var vNewUrl = new URL(paramsCurrentURL);

            // get parameters
            var vUname = vNewUrl.searchParams.get("user_name");
            var vFname = vNewUrl.searchParams.get("first_name");
            var vLname = vNewUrl.searchParams.get("last_name");

            // Save to global variable
            gPlayerInfoObj.userName = vUname;
            gPlayerInfoObj.firstName = vFname;
            gPlayerInfoObj.lastName = vLname;

            // show result in console.log
            console.log("gPlayerInfoObj = " + JSON.stringify(gPlayerInfoObj, null, 2));
        }
        function loadPlayerInfoToForm(paramDataObj) {
            $('#user-name').val(paramDataObj.userName);
            $('#first-name').val(paramDataObj.firstName);
            $('#last-name').val(paramDataObj.lastName);
        }
        function getPlayerDiceHistory(paramUserName) {
            console.log(paramUserName);

            $.ajax({
                url: gBASE_URL + "/dice-history?username=" + paramUserName,
                async: false,
                type: 'GET',
                dataType: 'json',
                success: function (responseObject) {
                    console.log('responseText >>> ' + JSON.stringify(responseObject));
                    if (responseObject.dices.length > 0) {
                        var vCount = 0;
                        while (vCount < responseObject.dices.length) {
                            var bDice = { 'game': vCount, 'dice': responseObject.dices[vCount] };
                            gDiceHistoryData.push(bDice);
                            vCount++;
                        }
                        loadDataToDiceTable(gDiceHistoryData);
                    }
                },
                error: function (xhr, status, error) {
                    console.log(error);
                }
            });
        }
        /*** REGION 4 Common functions Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
        function loadDataToDiceTable(paramVoucherArr) {
            console.log(paramVoucherArr);
            gPlayerDataTable.clear();
            gPlayerDataTable.rows.add(paramVoucherArr);
            gPlayerDataTable.draw();
        }




    </script>